'extractresult.bas
'usage: extractresult [extraoffset]
'df6nm 19-02-19

'$ lang: "qb"
#INCLUDE "datetime.bi"
'#INCLUDE "vbcompat.bi"
deflng a-z

extraoffset!=0
cmd$ = ltrim$(rtrim$(command$))
if len(cmd$)>=1 then extraoffset!=val(cmd$) 

OPEN "fft-log.txt" FOR INPUT AS 1
found$="":EbN0s!=99.9
while not eof(1)
 line input #1, i$
 '? i$
 if left$(i$,13)="rx frequency " then rxfreq#=val(right$(i$,len(i$)-13))
 if left$(i$,16)="file start time " then datetime$=right$(i$,len(i$)-16)
 if left$(i$,11)="polynomial " then polynomial$=right$(i$,len(i$)-11)
 if left$(i$,9)="crc size " then crc=val(right$(i$,len(i$)-9))
 if left$(i$,16)="number of chars " then chars=val(right$(i$,len(i$)-16))
 if left$(i$,14)="symbol period " then symboltime!=val(right$(i$,len(i$)-14))
 if left$(i$,13)="start offset " then startoffset!=val(right$(i$,len(i$)-13))
 if left$(i$,12)="freq offset " then freqoffset#=val(right$(i$,len(i$)-12))
 if left$(i$,6)="found " then found$=right$(i$,len(i$)-6)
 if left$(i$,10)="list rank " then rank=val(right$(i$,len(i$)-10))
 if left$(i$,14)="carrier Eb/N0 " then EbN0c!=val(right$(i$,len(i$)-14))
 if left$(i$,13)="symbol Eb/N0 " then EbN0s!=val(right$(i$,len(i$)-13))
 if left$(i$,25)="Eb/N0 from symbol errors " then EbN0s!=val(right$(i$,len(i$)-25))
wend
CLOSE 1

if found$<>"" then
 ts#=DATESERIAL(val(left$(datetime$,4)),val(mid$(datetime$,6,2)),val(mid$(datetime$,9,2)))
 ts#=ts#+val(mid$(datetime$,12,2))/24+val(mid$(datetime$,15,2))/24/60+val(mid$(datetime$,18,6))/86400
 ts#=ts#+(startoffset!-extraoffset!+.5)/86400#
 startdate$=right$(str$(year(ts#)),4)+"-"+right$(str$(100+month(ts#)),2)+"-"+right$(str$(100+day(ts#)),2)
 starttime$=right$(str$(100+hour(ts#)),2)+":"+right$(str$(100+minute(ts#)),2)+":"+right$(str$(100+second(ts#)),2)
 code$=right$("      "+polynomial$,6)
 ? using "& &#######.###Hz";startdate$;starttime$;rxfreq#+freqoffset#;
 ? using "### ##.#s & ##";chars;symboltime!;code$;crc;
 ? using " ##.#dB ##.#dB##### ";EbN0c!;EbN0s!;rank;
 ? found$
endif

end
